package edu.uoc.tfg.nutriknow.utils;

import android.view.View;

import androidx.test.espresso.matcher.BoundedMatcher;

import com.google.android.material.textfield.TextInputLayout;

import org.hamcrest.Description;
import org.hamcrest.Matcher;

import static org.hamcrest.Matchers.is;

public class ErrorMatcher {

    public static Matcher<View> withError(final String substring) {
        return withError(is(substring));
    }

    public static Matcher<View> withError(final Matcher<String> stringMatcher) {
        return new BoundedMatcher<View, TextInputLayout>(TextInputLayout.class) {

            @Override
            public boolean matchesSafely(TextInputLayout view) {
                final CharSequence error = view.getError();
                return error != null && stringMatcher.matches(error.toString());
            }

            @Override
            public void describeTo(Description description) {
                description.appendText("with error: ");
                stringMatcher.describeTo(description);
            }
        };
    }
}

