package edu.uoc.tfg.nutriknow.model;

import com.google.gson.annotations.SerializedName;

import java.io.Serializable;

/**
 * Additives classes representation class
 */
public class AdditivesClasses implements Serializable {

    public AdditivesClasses(){
        
    }
    
    @SerializedName("en:concentrated-plant-colour")
    public AdditiveClass enConcentratedPlantColour;
    @SerializedName("en:bulking-agent")
    public AdditiveClass enBulkingAgent;
    @SerializedName("en:humectant")
    public AdditiveClass enHumectant;
    @SerializedName("en:acid")
    public AdditiveClass enAcid;
    @SerializedName("en:colour-retention-agent")
    public AdditiveClass enColourRetentionAgent;
    @SerializedName("en:carrier")
    public AdditiveClass enCarrier;
    @SerializedName("en:vitamins")
    public AdditiveClass enVitamins;
    @SerializedName("en:raising-agent")
    public AdditiveClass enRaisingAgent;
    @SerializedName("en:natural-firming-agent")
    public AdditiveClass enNaturalFirmingAgent;
    @SerializedName("en:cooking-enhancer")
    public AdditiveClass enCookingEnhancer;
    @SerializedName("fr:agent-cremeux")
    public AdditiveClass frAgentCremeux;
    @SerializedName("en:glazing-agent")
    public AdditiveClass enGlazingAgent;
    @SerializedName("en:natural-stabilizer")
    public AdditiveClass enNaturalStabilizer;
    @SerializedName("en:foaming-agent")
    public AdditiveClass enFoamingAgent;
    @SerializedName("en:fruit-preservative")
    public AdditiveClass enFruitPreservative;
    @SerializedName("en:enhancer")
    public AdditiveClass enEnhancer;
    @SerializedName("en:flavour-enhancer")
    public AdditiveClass enFlavourEnhancer;
    @SerializedName("en:sweetener")
    public AdditiveClass enSweetener;
    @SerializedName("en:emulsifier")
    public AdditiveClass enEmulsifier;
    @SerializedName("en:gelling-agent")
    public AdditiveClass enGellingAgent;
    @SerializedName("fr:denree-alimentaire-colorante")
    public AdditiveClass frDenreeAlimentaireColorante;
    @SerializedName("en:nucleotides")
    public AdditiveClass enNucleotides;
    @SerializedName("en:other-nutritional-substances")
    public AdditiveClass enOtherNutritionalSubstances;
    @SerializedName("en:flour-treatment-agent")
    public AdditiveClass enFlourTreatmentAgent;
    @SerializedName("en:propellent-gas")
    public AdditiveClass enPropellentGas;
    @SerializedName("en:sequestrant")
    public AdditiveClass enSequestrant;
    @SerializedName("en:natural-antioxidant")
    public AdditiveClass enNaturalAntioxidant;
    @SerializedName("en:stabiliser")
    public AdditiveClass enStabiliser;
    @SerializedName("en:thickener")
    public AdditiveClass enThickener;
    @SerializedName("en:preservative")
    public AdditiveClass enPreservative;
    @SerializedName("fr:colorant-de-la-croute")
    public AdditiveClass frColorantDeLaCroute;
    @SerializedName("fr:additifs-alimentaires")
    public AdditiveClass frAdditifsAlimentaires;
    @SerializedName("en:antioxidant")
    public AdditiveClass enAntioxidant;
    @SerializedName("en:bread-improver")
    public AdditiveClass enBreadImprover;
    @SerializedName("en:colour")
    public AdditiveClass enColour;
    @SerializedName("en:vitamin-and-mineral-blend")
    public AdditiveClass enVitaminAndMineralBlend;
    @SerializedName("en:carbonating-agent")
    public AdditiveClass enCarbonatingAgent;
    @SerializedName("en:natural-emulsifier")
    public AdditiveClass enNaturalEmulsifier;
    @SerializedName("fr:conservateur-de-surface")
    public AdditiveClass frConservateurDeSurface;
    @SerializedName("en:natural-colours")
    public AdditiveClass enNaturalColours;
    @SerializedName("en:coagulant")
    public AdditiveClass enCoagulant;
    @SerializedName("en:natural-thickener")
    public AdditiveClass enNaturalThickener;
    @SerializedName("en:modified-starch")
    public AdditiveClass enModifiedStarch;
    @SerializedName("en:natural-preservative")
    public AdditiveClass enNaturalPreservative;
    @SerializedName("en:bleaching-agent")
    public AdditiveClass enBleachingAgent;
    @SerializedName("en:emulsifying-salts")
    public AdditiveClass enEmulsifyingSalts;
    @SerializedName("en:packaging-gas")
    public AdditiveClass enPackagingGas;
    @SerializedName("en:salt-substitute")
    public AdditiveClass enSaltSubstitute;
    @SerializedName("en:anti-caking-agent")
    public AdditiveClass enAntiCakingAgent;
    @SerializedName("en:minerals")
    public AdditiveClass enMinerals;
    @SerializedName("en:anti-foaming-agent")
    public AdditiveClass enAntiFoamingAgent;
    @SerializedName("en:anti-bulking-agent")
    public AdditiveClass enAntiBulkingAgent;
    @SerializedName("en:firming-agent")
    public AdditiveClass enFirmingAgent;
    @SerializedName("en:acidity-regulator")
    public AdditiveClass enAcidityRegulator;
    @SerializedName("en:amino-acids")
    public AdditiveClass enAminoAcids;

    public static class AdditiveClass implements Serializable {

        public AdditiveClass() {

        }

        public AdditiveClass(Name description, Name wikidata, Name name) {
            this.description = description;
            this.wikidata = wikidata;
            this.name = name;
        }

        public String code;
        public Name description;
        public Name wikidata;
        public Name name;

        public static class Name implements Serializable {

            public Name() {

            }

            public String en;
            public String es;
        }
    }

    public AdditiveClass getEnConcentratedPlantColour() {
        AdditiveClass additiveClass = new AdditiveClass(enConcentratedPlantColour.description,
                enConcentratedPlantColour.wikidata, enConcentratedPlantColour.name);
        additiveClass.code = "en:concentrated-plant-colour";
        return additiveClass;
    }

    public AdditiveClass getEnBulkingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enBulkingAgent.description,
                enBulkingAgent.wikidata, enBulkingAgent.name);
        additiveClass.code = "en:bulking-agent";
        return additiveClass;
    }

    public AdditiveClass getEnHumectant() {
        AdditiveClass additiveClass = new AdditiveClass(enHumectant.description,
                enHumectant.wikidata, enHumectant.name);
        additiveClass.code = "en:humectant";
        return additiveClass;
    }

    public AdditiveClass getEnAcid() {
        AdditiveClass additiveClass = new AdditiveClass(enAcid.description,
                enAcid.wikidata, enAcid.name);
        additiveClass.code = "en:acid";
        return additiveClass;
    }

    public AdditiveClass getEnColourRetentionAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enColourRetentionAgent.description,
                enColourRetentionAgent.wikidata, enColourRetentionAgent.name);
        additiveClass.code = "en:colour-retention-agent";
        return additiveClass;
    }

    public AdditiveClass getEnCarrier() {
        AdditiveClass additiveClass = new AdditiveClass(enCarrier.description,
                enCarrier.wikidata, enCarrier.name);
        additiveClass.code = "en:carrier";
        return additiveClass;
    }

    public AdditiveClass getEnVitamins() {
        AdditiveClass additiveClass = new AdditiveClass(enVitamins.description,
                enVitamins.wikidata, enVitamins.name);
        additiveClass.code = "en:vitamins";
        return additiveClass;
    }

    public AdditiveClass getEnRaisingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enRaisingAgent.description,
                enRaisingAgent.wikidata, enRaisingAgent.name);
        additiveClass.code = "en:raising-agent";
        return additiveClass;
    }

    public AdditiveClass getEnNaturalFirmingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enNaturalFirmingAgent.description,
                enNaturalFirmingAgent.wikidata, enNaturalFirmingAgent.name);
        additiveClass.code = "en:natural-firming-agent";
        return additiveClass;
    }

    public AdditiveClass getEnCookingEnhancer() {
        AdditiveClass additiveClass = new AdditiveClass(enCookingEnhancer.description,
                enCookingEnhancer.wikidata, enCookingEnhancer.name);
        additiveClass.code = "en:cooking-enhancer";
        return additiveClass;
    }

    public AdditiveClass getFrAgentCremeux() {
        AdditiveClass additiveClass = new AdditiveClass(frAgentCremeux.description,
                frAgentCremeux.wikidata, frAgentCremeux.name);
        additiveClass.code = "fr:agent-cremeux";
        return additiveClass;
    }

    public AdditiveClass getEnGlazingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enGlazingAgent.description,
                enGlazingAgent.wikidata, enGlazingAgent.name);
        additiveClass.code = "en:glazing-agent";
        return additiveClass;
    }

    public AdditiveClass getEnNaturalStabilizer() {
        AdditiveClass additiveClass = new AdditiveClass(enNaturalStabilizer.description,
                enNaturalStabilizer.wikidata, enNaturalStabilizer.name);
        additiveClass.code = "en:natural-stabilizer";
        return additiveClass;
    }

    public AdditiveClass getEnFoamingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enFoamingAgent.description,
                enFoamingAgent.wikidata, enFoamingAgent.name);
        additiveClass.code = "en:foaming-agent";
        return additiveClass;
    }

    public AdditiveClass getEnFruitPreservative() {
        AdditiveClass additiveClass = new AdditiveClass(enFruitPreservative.description,
                enFruitPreservative.wikidata, enFruitPreservative.name);
        additiveClass.code = "en:fruit-preservative";
        return additiveClass;
    }

    public AdditiveClass getEnEnhancer() {
        AdditiveClass additiveClass = new AdditiveClass(enEnhancer.description,
                enEnhancer.wikidata, enEnhancer.name);
        additiveClass.code = "en:enhancer";
        return additiveClass;
    }

    public AdditiveClass getEnFlavourEnhancer() {
        AdditiveClass additiveClass = new AdditiveClass(enFlavourEnhancer.description,
                enFlavourEnhancer.wikidata, enFlavourEnhancer.name);
        additiveClass.code = "en:flavour-enhancer";
        return additiveClass;
    }

    public AdditiveClass getEnSweetener() {
        AdditiveClass additiveClass = new AdditiveClass(enSweetener.description,
                enSweetener.wikidata, enSweetener.name);
        additiveClass.code = "en:sweetener";
        return additiveClass;
    }

    public AdditiveClass getEnEmulsifier() {
        AdditiveClass additiveClass = new AdditiveClass(enEmulsifier.description,
                enEmulsifier.wikidata, enEmulsifier.name);
        additiveClass.code = "en:emulsifier";
        return additiveClass;
    }

    public AdditiveClass getEnGellingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enGellingAgent.description,
                enGellingAgent.wikidata, enGellingAgent.name);
        additiveClass.code = "en:gelling-agent";
        return additiveClass;
    }

    public AdditiveClass getFrDenreeAlimentaireColorante() {
        AdditiveClass additiveClass = new AdditiveClass(frDenreeAlimentaireColorante.description,
                frDenreeAlimentaireColorante.wikidata, frDenreeAlimentaireColorante.name);
        additiveClass.code = "fr:denree-alimentaire-colorante";
        return additiveClass;
    }

    public AdditiveClass getEnNucleotides() {
        AdditiveClass additiveClass = new AdditiveClass(enNucleotides.description,
                enNucleotides.wikidata, enNucleotides.name);
        additiveClass.code = "en:nucleotides";
        return additiveClass;
    }

    public AdditiveClass getEnOtherNutritionalSubstances() {
        AdditiveClass additiveClass = new AdditiveClass(enOtherNutritionalSubstances.description,
                enOtherNutritionalSubstances.wikidata, enOtherNutritionalSubstances.name);
        additiveClass.code = "en:other-nutritional-substances";
        return additiveClass;
    }

    public AdditiveClass getEnFlourTreatmentAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enFlourTreatmentAgent.description,
                enFlourTreatmentAgent.wikidata, enFlourTreatmentAgent.name);
        additiveClass.code = "en:flour-treatment-agent";
        return additiveClass;
    }

    public AdditiveClass getEnPropellentGas() {
        AdditiveClass additiveClass = new AdditiveClass(enPropellentGas.description,
                enPropellentGas.wikidata, enPropellentGas.name);
        additiveClass.code = "en:propellent-gas";
        return additiveClass;
    }

    public AdditiveClass getEnSequestrant() {
        AdditiveClass additiveClass = new AdditiveClass(enSequestrant.description,
                enSequestrant.wikidata, enSequestrant.name);
        additiveClass.code = "en:sequestrant";
        return additiveClass;
    }

    public AdditiveClass getEnNaturalAntioxidant() {
        AdditiveClass additiveClass = new AdditiveClass(enNaturalAntioxidant.description,
                enNaturalAntioxidant.wikidata, enNaturalAntioxidant.name);
        additiveClass.code = "en:natural-antioxidant";
        return additiveClass;
    }

    public AdditiveClass getEnStabiliser() {
        AdditiveClass additiveClass = new AdditiveClass(enStabiliser.description,
                enStabiliser.wikidata, enStabiliser.name);
        additiveClass.code = "en:stabiliser";
        return additiveClass;
    }

    public AdditiveClass getEnStabilizer() {
        AdditiveClass additiveClass = new AdditiveClass(enStabiliser.description,
                enStabiliser.wikidata, enStabiliser.name);
        additiveClass.code = "en:stabilizer";
        return additiveClass;
    }

    public AdditiveClass getEnThickener() {
        AdditiveClass additiveClass = new AdditiveClass(enThickener.description,
                enThickener.wikidata, enThickener.name);
        additiveClass.code = "en:thickener";
        return additiveClass;
    }

    public AdditiveClass getEnPreservative() {
        AdditiveClass additiveClass = new AdditiveClass(enPreservative.description,
                enPreservative.wikidata, enPreservative.name);
        additiveClass.code = "en:preservative";
        return additiveClass;
    }

    public AdditiveClass getFrColorantDeLaCroute() {
        AdditiveClass additiveClass = new AdditiveClass(frColorantDeLaCroute.description,
                frColorantDeLaCroute.wikidata, frColorantDeLaCroute.name);
        additiveClass.code = "fr:colorant-de-la-croute";
        return additiveClass;
    }

    public AdditiveClass getFrAdditifsAlimentaires() {
        AdditiveClass additiveClass = new AdditiveClass(frAdditifsAlimentaires.description,
                frAdditifsAlimentaires.wikidata, frAdditifsAlimentaires.name);
        additiveClass.code = "fr:additifs-alimentaires";
        return additiveClass;
    }

    public AdditiveClass getEnAntioxidant() {
        AdditiveClass additiveClass = new AdditiveClass(enAntioxidant.description,
                enAntioxidant.wikidata, enAntioxidant.name);
        additiveClass.code = "en:antioxidant";
        return additiveClass;
    }

    public AdditiveClass getEnBreadImprover() {
        AdditiveClass additiveClass = new AdditiveClass(enBreadImprover.description,
                enBreadImprover.wikidata, enBreadImprover.name);
        additiveClass.code = "en:bread-improver";
        return additiveClass;
    }

    public AdditiveClass getEnColour() {
        AdditiveClass additiveClass = new AdditiveClass(enColour.description,
                enColour.wikidata, enColour.name);
        additiveClass.code = "en:colour";
        return additiveClass;
    }

    public AdditiveClass getEnVitaminAndMineralBlend() {
        AdditiveClass additiveClass = new AdditiveClass(enVitaminAndMineralBlend.description,
                enVitaminAndMineralBlend.wikidata, enVitaminAndMineralBlend.name);
        additiveClass.code = "en:vitamin-and-mineral-blend";
        return additiveClass;
    }

    public AdditiveClass getEnCarbonatingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enCarbonatingAgent.description,
                enCarbonatingAgent.wikidata, enCarbonatingAgent.name);
        additiveClass.code = "en:carbonating-agent";
        return additiveClass;
    }

    public AdditiveClass getEnNaturalEmulsifier() {
        AdditiveClass additiveClass = new AdditiveClass(enNaturalEmulsifier.description,
                enNaturalEmulsifier.wikidata, enNaturalEmulsifier.name);
        additiveClass.code = "en:natural-emulsifier";
        return additiveClass;
    }

    public AdditiveClass getFrConservateurDeSurface() {
        AdditiveClass additiveClass = new AdditiveClass(frConservateurDeSurface.description,
                frConservateurDeSurface.wikidata, frConservateurDeSurface.name);
        additiveClass.code = "fr:conservateur-de-surface";
        return additiveClass;
    }

    public AdditiveClass getEnNaturalColours() {
        AdditiveClass additiveClass = new AdditiveClass(enNaturalColours.description,
                enNaturalColours.wikidata, enNaturalColours.name);
        additiveClass.code = "en:natural-colours";
        return additiveClass;
    }

    public AdditiveClass getEnCoagulant() {
        AdditiveClass additiveClass = new AdditiveClass(enCoagulant.description,
                enCoagulant.wikidata, enCoagulant.name);
        additiveClass.code = "en:coagulant";
        return additiveClass;
    }

    public AdditiveClass getEnNaturalThickener() {
        AdditiveClass additiveClass = new AdditiveClass(enNaturalThickener.description,
                enNaturalThickener.wikidata, enNaturalThickener.name);
        additiveClass.code = "en:natural-thickener";
        return additiveClass;
    }

    public AdditiveClass getEnModifiedStarch() {
        AdditiveClass additiveClass = new AdditiveClass(enModifiedStarch.description,
                enModifiedStarch.wikidata, enModifiedStarch.name);
        additiveClass.code = "en:modified-starch";
        return additiveClass;
    }

    public AdditiveClass getEnNaturalPreservative() {
        AdditiveClass additiveClass = new AdditiveClass(enNaturalPreservative.description,
                enNaturalPreservative.wikidata, enNaturalPreservative.name);
        additiveClass.code = "en:natural-preservative";
        return additiveClass;
    }

    public AdditiveClass getEnBleachingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enBleachingAgent.description,
                enBleachingAgent.wikidata, enBleachingAgent.name);
        additiveClass.code = "en:bleaching-agent";
        return additiveClass;
    }

    public AdditiveClass getEnEmulsifyingSalts() {
        AdditiveClass additiveClass = new AdditiveClass(enEmulsifyingSalts.description,
                enEmulsifyingSalts.wikidata, enEmulsifyingSalts.name);
        additiveClass.code = "en:emulsifying-salts";
        return additiveClass;
    }

    public AdditiveClass getEnPackagingGas() {
        AdditiveClass additiveClass = new AdditiveClass(enPackagingGas.description,
                enPackagingGas.wikidata, enPackagingGas.name);
        additiveClass.code = "en:packaging-gas";
        return additiveClass;
    }

    public AdditiveClass getEnSaltSubstitute() {
        AdditiveClass additiveClass = new AdditiveClass(enSaltSubstitute.description,
                enSaltSubstitute.wikidata, enSaltSubstitute.name);
        additiveClass.code = "en:salt-substitute";
        return additiveClass;
    }

    public AdditiveClass getEnAntiCakingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enAntiCakingAgent.description,
                enAntiCakingAgent.wikidata, enAntiCakingAgent.name);
        additiveClass.code = "en:anti-caking-agent";
        return additiveClass;
    }

    public AdditiveClass getEnMinerals() {
        AdditiveClass additiveClass = new AdditiveClass(enMinerals.description,
                enMinerals.wikidata, enMinerals.name);
        additiveClass.code = "en:minerals";
        return additiveClass;
    }

    public AdditiveClass getEnAntiFoamingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enAntiFoamingAgent.description,
                enAntiFoamingAgent.wikidata, enAntiFoamingAgent.name);
        additiveClass.code = "en:anti-foaming-agent";
        return additiveClass;
    }

    public AdditiveClass getEnAntiBulkingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enAntiBulkingAgent.description,
                enAntiBulkingAgent.wikidata, enAntiBulkingAgent.name);
        additiveClass.code = "en:anti-bulking-agent";
        return additiveClass;
    }

    public AdditiveClass getEnFirmingAgent() {
        AdditiveClass additiveClass = new AdditiveClass(enFirmingAgent.description,
                enFirmingAgent.wikidata, enFirmingAgent.name);
        additiveClass.code = "en:firming-agent";
        return additiveClass;
    }

    public AdditiveClass getEnAcidityRegulator() {
        AdditiveClass additiveClass = new AdditiveClass(enAcidityRegulator.description,
                enAcidityRegulator.wikidata, enAcidityRegulator.name);
        additiveClass.code = "en:acidity-regulator";
        return additiveClass;
    }

    public AdditiveClass getEnAminoAcids() {
        AdditiveClass additiveClass = new AdditiveClass(enAminoAcids.description,
                enAminoAcids.wikidata, enAminoAcids.name);
        additiveClass.code = "en:amino-acids";
        return additiveClass;
    }
}
