package edu.uoc.tfg.nutriknow.model;

import com.google.gson.annotations.SerializedName;

import java.util.ArrayList;
import java.util.List;

/**
 * Open Food Facts product information response representation class
 */
public class CompleteProductData {

    public CompleteProductData() {
    }

    public Integer status;
    public String code;
    public String status_verbose;
    public ProductData product;

    public static class ProductData {

        public ProductData() {
        }

        public List<String> categories_hierarchy = new ArrayList<>();
        public String image_front_url;
        public List<String> states_hierarchy = new ArrayList<>();
        public String serving_quantity;
        public String link;
        public List<String> data_quality_tags = new ArrayList<>();
        public String nutrition_data_prepared_per_imported;
        public List<String> product_name_debug_tags = new ArrayList<>();
        public String emb_codes_orig;
        public List<String> data_sources_tags = new ArrayList<>();
        public Integer known_ingredients_n;
        public List<String> ingredients_that_may_be_from_palm_oil_tags = new ArrayList<>();
        public String image_url;
        public String interface_version_modified;
        public List<String> purchase_places_tags = new ArrayList<>();
        public float completeness;
        public List<String> ingredients_debug = new ArrayList<>();
        public List<String> debug_param_sorted_langs = new ArrayList<>();
        public Integer ingredients_n;
        public Long popularity_key;
        public NutriscoreData nutriscore_data;
        public String ingredients_text_with_allergens_fr;
        public List<String> emb_codes_tags = new ArrayList<>();
        public Integer nutrition_score_beverage;
        public List<String> informers_tags = new ArrayList<>();
        public List<String> nucleotides_prev_tags = new ArrayList<>();
        public List<String> languages_tags = new ArrayList<>();
        public Integer nova_group;
        public String origins;
        public String generic_name;
        public List<String> brands_tags = new ArrayList<>();
        public Integer unknown_ingredients_n;
        public Integer rev;
        public String image_thumb_url;
        public Long last_image_t;
        public List<String> ingredients_tags = new ArrayList<>();
        public Integer nutriscore_score;
        public LanguagesCodes languages_codes;
        public String categories;
        public List<String> other_nutritional_substances_tags = new ArrayList<>();
        public String brands;
        public String nutrition_data_prepared;
        public String nutrition_grade_fr;
        public List<String> origins_tags = new ArrayList<>();
        public String allergens_from_ingredients;
        public List<String> correctors_tags = new ArrayList<>();
        public String ingredients_text_fr;
        public List<String> additives_old_tags = new ArrayList<>();
        public String categories_lc;
        public String nutriscore_grade;
        public Images images;
        public String data_sources_imported;
        public List<String> nucleotides_tags = new ArrayList<>();
        public Integer ingredients_from_palm_oil_n;
        public String nutrition_grades;
        public List<String> data_quality_bugs_tags = new ArrayList<>();
        public String origins_lc;
        public Integer unique_scans_n;
        public String traces;
        public List<String> pnns_groups_1_tags = new ArrayList<>();
        public Float nutrition_score_warning_fruits_vegetables_nuts_estimate_from_ingredients_value;
        public List<String> traces_tags = new ArrayList<>();
        public String max_imgid;
        public Long sortkey;
        public List<String> data_quality_warnings_tags = new ArrayList<>();
        public List<String> additives_prev_original_tags = new ArrayList<>();
        public Long last_modified_t;
        public String manufacturing_places;
        public String creator;
        public String data_sources;
        public String lang;
        public String nova_groups;
        public String pnns_groups_2;
        public List<String> traces_hierarchy = new ArrayList<>();
        public Integer additives_old_n;
        public String interface_version_created;
        public Integer ingredients_from_or_that_may_be_from_palm_oil_n;
        public String purchase_places;
        public List<String> stores_tags = new ArrayList<>();
        public String product_name_es;
        public String countries_lc;
        public String packaging;
        public String states;
        public List<String> ingredients_analysis_tags = new ArrayList<>();
        public List<String> nova_groups_tags = new ArrayList<>();
        public List<String> amino_acids_prev_tags = new ArrayList<>();
        public List<String> minerals_tags = new ArrayList<>();
        public List<String> photographers_tags = new ArrayList<>();
        public CategoryProperties category_properties;
        public String pnns_groups_1;
        public List<String> popularity_tags = new ArrayList<String>();
        public List<Source> sources = new ArrayList<>();
        public String generic_name_es;
        public List<String> countries_tags = new ArrayList<>();
        public String product_name;
        public String image_ingredients_small_url;
        public String image_nutrition_url;
        public String traces_lc;
        public List<String> ingredients_ids_debug = new ArrayList<>();
        public List<String> additives_tags = new ArrayList<>();
        public List<String> pnns_groups_2_tags = new ArrayList<>();
        public List<String> nutrient_levels_tags = new ArrayList<>();
        public String lc;
        public List<String> allergens_hierarchy = new ArrayList<>();
        public List<String> nova_group_tags = new ArrayList<>();
        public List<String> categories_properties_tags = new ArrayList<>();
        public String generic_name_fr;
        public List<String> labels_tags = new ArrayList<>();
        public String image_nutrition_small_url;
        public String ingredients_text_with_allergens_es;
        public String countries_imported;
        public List<String> last_edit_dates_tags = new ArrayList<>();
        public String last_modified_by;
        public List<String> languages_hierarchy = new ArrayList<>();
        public List<String> nutrition_grades_tags = new ArrayList<>();
        public String last_editor;
        public CategoriesProperties categories_properties;
        public Languages languages;
        public List<String> last_image_dates_tags = new ArrayList<>();
        public String ingredients_text_with_allergens;
        public List<String> additives_debug_tags = new ArrayList<>();
        public String traces_from_user;
        public List<String> minerals_prev_tags = new ArrayList<>();
        public List<String> ingredients_original_tags = new ArrayList<>();
        public String nutrition_data_prepared_per;
        public List<String> unknown_nutrients_tags = new ArrayList<>();
        public String nova_group_debug;
        public NutrientLevels nutrient_levels;
        public Nutriments nutriments;
        public List<String> ingredients_from_palm_oil_tags = new ArrayList<>();
        public Integer nutrition_score_warning_no_fiber;
        public String serving_size;
        public String product_name_fr;
        public String image_small_url;
        public String ingredients_text;
        public List<String> allergens_tags = new ArrayList<>();
        public List<String> editors_tags = new ArrayList<>();
        public List<Ingredient> ingredients = new ArrayList<>();
        public List<String> countries_hierarchy = new ArrayList<>();
        public List<String> _keywords = new ArrayList<>();
        public List<String> manufacturing_places_tags = new ArrayList<>();
        public Integer nutrition_score_warning_fruits_vegetables_nuts_estimate_from_ingredients;
        public List<String> amino_acids_tags = new ArrayList<>();
        public String image_ingredients_thumb_url;
        public String labels_lc;
        public String image_ingredients_url;
        public List<String> cities_tags = new ArrayList<>();
        public String labels;
        public String allergens_from_user;
        public String expiration_date;
        public List<String> additives_original_tags = new ArrayList<>();
        public String image_nutrition_thumb_url;
        public String origins_old;
        public List<String> categories_tags = new ArrayList<>();
        public String allergens;
        public String allergens_lc;
        public List<String> checkers_tags = new ArrayList<>();
        public String nutrition_data_per;
        public List<String> origins_hierarchy = new ArrayList<>();
        public String image_front_small_url;
        public List<String> data_quality_info_tags = new ArrayList<>();
        public List<String> ingredients_n_tags = new ArrayList<>();
        public String no_nutrition_data;
        public List<String> data_quality_errors_tags = new ArrayList<>();
        public List<String> packaging_tags = new ArrayList<>();
        public String code;
        public Long created_t;
        public String emb_codes;
        public String ingredients_text_es;
        public String ingredients_text_en;
        public String nutrition_data;
        public String quantity;
        public List<String> ingredients_hierarchy = new ArrayList<>();
        public String countries;
        public String ingredients_text_debug;
        public String stores;
        public Integer scans_n;
        public Integer ingredients_percent_analysis;
        public Integer additives_n;
        public String traces_from_ingredients;
        public List<String> states_tags = new ArrayList<>();
        public List<String> vitamins_tags = new ArrayList<>();
        public String image_front_thumb_url;
        public Integer complete;
        public Integer ingredients_that_may_be_from_palm_oil_n;
        public List<String> vitamins_prev_tags = new ArrayList<>();
        public String update_key;
        public String _id;
        public String compared_to_category;
        public List<String> labels_hierarchy = new ArrayList<>();
        public String nutrition_data_per_imported;
        public String lc_imported;
        public List<String> ciqual_food_name_tags = new ArrayList<>();
        public List<String> entry_dates_tags = new ArrayList<>();
        public List<String> misc_tags = new ArrayList<>();
        public List<String> codes_tags = new ArrayList<>();
        public SelectedImages selected_images;
        public String id;

        public static class SelectedImages {

            public SelectedImages() {

            }

            public SelectedImage ingredients;
            public SelectedImage nutrition;
            public SelectedImage front;

            public static class SelectedImage {

                public SelectedImage() {

                }

                public Thumb small;
                public Thumb thumb;
                public Thumb display;
            }

            public static class Thumb {

                public Thumb() {

                }

                public String fr;
                public String es;
            }
        }

        public static class NutrientLevels {

            public NutrientLevels() {

            }

            public String fat;
            public String salt;
            public String sugars;
            @SerializedName("saturated-fat")
            public String saturated_fat;
        }

        public static class Nutriments {

            public Nutriments() {

            }

            public String salt_unit;
            @SerializedName("nutrition-score-fr_100g")
            public float nutrition_score_fr_100g;
            @SerializedName("nutrition-score-fr")
            public float nutrition_score_fr;
            public String sugars_unit;
            public float sodium_100g;
            public float carbohydrates_serving;
            public float energy_value;
            public float salt_serving;
            public String carbohydrates_unit;
            public float sugars_serving;
            public float energy_100g;
            public float fat_value;
            @SerializedName("energy-kcal_serving")
            public float energy_kcal_serving;
            public float fat_serving;
            public float proteins_100g;
            @SerializedName("nova-group_100g")
            public float nova_group_100g;
            @SerializedName("saturated-fat")
            public float saturated_fat;
            public float sugars_100g;
            @SerializedName("energy-kcal_100g")
            public float energy_kcal_100g;
            public float salt;
            @SerializedName("saturated-fat_100g")
            public float saturated_fat_100g;
            public String energy_unit;
            public float carbohydrates_value;
            public String fat_unit;
            public float salt_100g;
            @SerializedName("energy-kcal_value")
            public float energy_kcal_value;
            @SerializedName("nova-group_serving")
            public float nova_group_serving;
            @SerializedName("saturated-fat_serving")
            public float saturated_fat_serving;
            public String sodium_unit;
            public float carbohydrates;
            public float fat;
            public float fat_100g;
            public float sodium_value;
            public float proteins_value;
            @SerializedName("nova-group")
            public float nova_group;
            public float energy_serving;
            public float sodium;
            public float proteins_serving;
            public float sodium_serving;
            public float energy;
            @SerializedName("fruits-vegetables-nuts-estimate-from-ingredients_100g")
            public float fruits_vegetables_nuts_estimate_from_ingredients_100g;
            @SerializedName("saturated-fat_value")
            public float saturated_fat_value;
            public float proteins;
            public float sugars_value;
            @SerializedName("saturated-fat_unit")
            public String saturated_fat_unit;
            @SerializedName("energy-kcal_unit")
            public String energy_kcal_unit;
            public String proteins_unit;
            public float carbohydrates_100g;
            public float sugars;
            public float salt_value;
            @SerializedName("energy-kcal")
            public float energy_kcal;
        }

        public static class Languages {

            public Languages() {

            }

            @SerializedName("en:spanish")
            public Integer en_spanish;
            @SerializedName("en:french")
            public Integer en_french;
        }

        public static class CategoriesProperties {

            public CategoriesProperties() {

            }

            @SerializedName("agribalyse_food_code:en")
            public String agribalyse_food_code_en;
            @SerializedName("ciqual_food_code:en")
            public String ciqual_food_code_en;
        }

        public static class CategoryProperties {

            public CategoryProperties() {

            }

            @SerializedName("ciqual_food_name:en")
            public String ciqual_food_name_en;
            @SerializedName("ciqual_food_name:fr")
            public String ciqual_food_name_fr;

        }

        public static class Source {

            public Source() {

            }

            public List<String> fields = new ArrayList<>();
            public String url;
            public List<Object> images = new ArrayList<>();
            public String id;
            public Integer manufacturer;
            public String name;
            public Long import_t;
        }

        public static class Images {

            public Images() {

            }

            @SerializedName("1")
            public ImageData one;
            @SerializedName("2")
            public ImageData two;
            @SerializedName("3")
            public ImageData three;
            @SerializedName("4")
            public ImageData four;
            @SerializedName("5")
            public ImageData five;
            @SerializedName("6")
            public ImageData six;
            @SerializedName("7")
            public ImageData seven;
            public ImageCharacteristics nutrition_es;
            public Front front_es;
            public ImageCharacteristics ingredients_es;
            public Front front_fr;
            public ImageCharacteristics ingredients_fr;

            public static class ImageCharacteristics {

                public ImageCharacteristics() {

                }

                public Sizes sizes;
                public String y1;
                public String orientation;
                public String rev;
                public Integer ocr;
                public String imgid;
                public String x2;
                public String y2;
                public String geometry;
                public String white_magic;
                public String x1;
                public String angle;
                public String normalize;
            }

            public static class Front {

                public Front() {

                }

                public String normalize;
                public String white_magic;
                public String x1;
                public String angle;
                public String geometry;
                public String y2;
                public String x2;
                public String imgid;
                public String rev;
                public String y1;
                public Sizes sizes;
            }

            public static class ImageData {

                public ImageData() {

                }

                public String uploader;
                public Long uploaded_t;
                public Sizes sizes;
            }

            public static class Sizes {

                public Sizes() {

                }

                @SerializedName("100")
                public Full one_hundred;
                @SerializedName("200")
                public Full two_hundred;
                @SerializedName("400")
                public Full four_hundred;

                public class Full {

                    public Full() {

                    }

                    public float h;
                    public float w;
                }
            }
        }

        public static class LanguagesCodes {

            public LanguagesCodes() {

            }

            public Integer fr;
            public Integer es;
        }

        public static class NutriscoreData {

            public NutriscoreData() {

            }

            public float saturated_fat_ratio;
            public float sodium_value;
            public float saturated_fat_value;
            public float fruits_vegetables_nuts_colza_walnut_olive_oils_value;
            public float saturated_fat_points;
            public float proteins_points;
            public float sodium;
            public float score;
            public float fiber_value;
            public float proteins_value;
            public float is_water;
            public float proteins;
            public float energy;
            public float is_beverage;
            public float sugars;
            public float fruits_vegetables_nuts_colza_walnut_olive_oils_points;
            public float sugars_value;
            public float fruits_vegetables_nuts_colza_walnut_olive_oils;
            public float positive_points;
            public float saturated_fat;
            public float saturated_fat_ratio_value;
            public float negative_points;
            public float energy_value;
            public float fiber;
            public String grade;
            public float energy_points;
            public float is_fat;
            public float sugars_points;
            public float is_cheese;
            public float saturated_fat_ratio_points;
            public float sodium_points;
            public float fiber_points;
        }

        public static class Ingredient {

            public Ingredient() {

            }

            public Integer rank;
            public String id;
            public String text;
            public float percent_max;
            public float percent_min;
            public String has_sub_ingredients;
            public String vegetarian;
            public String vegan;
        }
    }
}
