package edu.uoc.tfg.nutriknow.model;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

/**
 * Class for store the user information and the catalog from database during activity
 */
public class DataHolder {

    // User information fields
    private User user;
    private Profile profile;
    private Locale currentLocale;
    private List<Product> products = new ArrayList<>();
    private List<Search> searches = new ArrayList<>();
    private List<Favorite> favorites = new ArrayList<>();
    private String firebaseToken;

    // Catalog form database fields
    private Map<String, List<Allergens.Allergen>> allergens = new HashMap<>();
    private Map<String, List<Labels.Label>> labels = new HashMap<>();
    private Map<String, List<Categories.Category>> categories = new HashMap<>();
    private Map<String, List<IngredientsAnalysis.IngredientAnalysis>> ingredientsAnalysis = new HashMap<>();
    private NutrientsLevel nutrientLevels;
    private NovaGroups novaGroups;
    private AdditivesClasses additivesClasses;
    private List<Additives> additives = new ArrayList<>();

    private static final DataHolder dataHolder = new DataHolder();

    public static DataHolder getInstance() {
        return dataHolder;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Map<String, List<Allergens.Allergen>> getAllergens() {
        return allergens;
    }

    public void setAllergens(Map<String, List<Allergens.Allergen>> allergens) {
        this.allergens = allergens;
    }

    public Profile getProfile() {
        return profile;
    }

    public void setProfile(Profile profile) {
        this.profile = profile;
    }

    public Locale getCurrentLocale() {
        return currentLocale;
    }

    public void setCurrentLocale(Locale currentLocale) {
        this.currentLocale = currentLocale;
    }

    public Map<String, List<Labels.Label>> getLabels() {
        return labels;
    }

    public void setLabels(Map<String, List<Labels.Label>> labels) {
        this.labels = labels;
    }

    public Map<String, List<Categories.Category>> getCategories() {
        return categories;
    }

    public void setCategories(Map<String, List<Categories.Category>> categories) {
        this.categories = categories;
    }

    public Map<String, List<IngredientsAnalysis.IngredientAnalysis>> getIngredientsAnalysis() {
        return ingredientsAnalysis;
    }

    public void setIngredientsAnalysis(Map<String, List<IngredientsAnalysis.IngredientAnalysis>> ingredientsAnalysis) {
        this.ingredientsAnalysis = ingredientsAnalysis;
    }

    public NutrientsLevel getNutrientLevels() {
        return nutrientLevels;
    }

    public void setNutrientLevels(NutrientsLevel nutrientLevels) {
        this.nutrientLevels = nutrientLevels;
    }

    public NovaGroups getNovaGroups() {
        return novaGroups;
    }

    public void setNovaGroups(NovaGroups novaGroups) {
        this.novaGroups = novaGroups;
    }

    public AdditivesClasses getAdditivesClasses() {
        return additivesClasses;
    }

    public void setAdditivesClasses(AdditivesClasses additivesClasses) {
        this.additivesClasses = additivesClasses;
    }

    public List<Additives> getAdditives() {
        return additives;
    }

    public void setAdditives(List<Additives> additives) {
        this.additives = additives;
    }

    public List<Product> getProducts() {
        return products;
    }

    public void setProducts(List<Product> products) {
        this.products = products;
    }

    public List<Search> getSearches() {
        return searches;
    }

    public void setSearches(List<Search> searches) {
        this.searches = searches;
    }

    public List<Favorite> getFavorites() {
        return favorites;
    }

    public void setFavorites(List<Favorite> favorites) {
        this.favorites = favorites;
    }

    public String getFirebaseToken() {
        return firebaseToken;
    }

    public void setFirebaseToken(String firebaseToken) {
        this.firebaseToken = firebaseToken;
    }
}
