package edu.uoc.tfg.nutriknow.model;

import com.google.gson.annotations.SerializedName;

import java.io.Serializable;

/**
 * Nova groups representation class
 */
public class NovaGroups implements Serializable {

    public NovaGroups() {

    }

    @SerializedName("en:4-ultra-processed-food-and-drink-products")
    public NovaGroup en4UltraProcessedFoodAndDrinkProducts;
    @SerializedName("en:3-processed-foods")
    public NovaGroup en3ProcessedFoods;
    @SerializedName("en:not-applicable")
    public NovaGroup enNotApplicable;
    @SerializedName("en:1-unprocessed-or-minimally-processed-foods")
    public NovaGroup en1UnprocessedOrMinimallyProcessedFoods;
    @SerializedName("en:2-processed-culinary-ingredients")
    public NovaGroup en2ProcessedCulinaryIngredients;

    public static class NovaGroup implements Serializable {

        public NovaGroup() {

        }

        public NovaGroup(String code, Name name) {
            this.code = code;
            this.name = name;
        }

        public String code;
        public Name name;

        public static class Name implements Serializable {

            public Name() {

            }

            public String en;
            public String es;
        }
    }

    public NovaGroup getEn4UltraProcessedFoodAndDrinkProducts() {
        NovaGroup novaGroup = new NovaGroup(en4UltraProcessedFoodAndDrinkProducts.code,
                en4UltraProcessedFoodAndDrinkProducts.name);
        novaGroup.code = "en:4-ultra-processed-food-and-drink-products";
        return novaGroup;
    }

    public NovaGroup getEn3ProcessedFoods() {
        NovaGroup novaGroup = new NovaGroup(en3ProcessedFoods.code,
                en3ProcessedFoods.name);
        novaGroup.code = "en:3-processed-foods";
        return novaGroup;
    }

    public NovaGroup getEnNotApplicable() {
        NovaGroup novaGroup = new NovaGroup(enNotApplicable.code,
                enNotApplicable.name);
        novaGroup.code = "en:not-applicable";
        return novaGroup;
    }

    public NovaGroup getEn1UnprocessedOrMinimallyProcessedFoods() {
        NovaGroup novaGroup = new NovaGroup(en1UnprocessedOrMinimallyProcessedFoods.code,
                en1UnprocessedOrMinimallyProcessedFoods.name);
        novaGroup.code = "en:1-unprocessed-or-minimally-processed-foods";
        return novaGroup;
    }

    public NovaGroup getEn2ProcessedCulinaryIngredients() {
        NovaGroup novaGroup = new NovaGroup(en2ProcessedCulinaryIngredients.code,
                en2ProcessedCulinaryIngredients.name);
        novaGroup.code = "en:2-processed-culinary-ingredients";
        return novaGroup;
    }
}
