package edu.uoc.tfg.nutriknow.model;

import com.google.gson.annotations.SerializedName;

import java.io.Serializable;

/**
 * Nutrients levels representation class
 */
public class NutrientsLevel implements Serializable {

    public NutrientsLevel() {

    }

    @SerializedName("en:fat-in-high-quantity")
    public NutrientLevel enFatInHighQuantity;
    @SerializedName("en:sugars-in-moderate-quantity")
    public NutrientLevel enSugarsInModerateQuantity;
    @SerializedName("en:fat-in-moderate-quantity")
    public NutrientLevel enFatInModerateQuantity;
    @SerializedName("en:sugars-in-high-quantity")
    public NutrientLevel enSugarsInHighQuantity;
    @SerializedName("en:fat-in-low-quantity")
    public NutrientLevel enFatInLowQuantity;
    @SerializedName("en:saturated-fat-in-high-quantity")
    public NutrientLevel enSaturatedFatInHighQuantity;
    @SerializedName("en:saturated-fat-in-low-quantity")
    public NutrientLevel enSaturatedFatInLowQuantity;
    @SerializedName("en:sugars-in-low-quantity")
    public NutrientLevel enSugarsInLowQuantity;
    @SerializedName("en:salt-in-moderate-quantity")
    public NutrientLevel enSaltInModerateQuantity;
    @SerializedName("en:salt-in-low-quantity")
    public NutrientLevel enSaltInLowQuantity;
    @SerializedName("en:salt-in-high-quantity")
    public NutrientLevel enSaltInHighQuantity;
    @SerializedName("en:saturated-fat-in-moderate-quantity")
    public NutrientLevel enSaturatedFatInModerateQuantity;

    public static class NutrientLevel implements Serializable {

        public NutrientLevel() {

        }

        public NutrientLevel(String code, Name name) {
            this.code = code;
            this.name = name;
        }

        public String code;
        public Name name;

        public static class Name implements Serializable {

            public Name() {

            }

            public String en;
            public String es;
        }
    }

    public NutrientLevel getEnFatInHighQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enFatInHighQuantity.code,
                enFatInHighQuantity.name);
        nutrientLevel.code = "en:fat-in-high-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnSugarsInModerateQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enSugarsInModerateQuantity.code,
                enSugarsInModerateQuantity.name);
        nutrientLevel.code = "en:sugars-in-moderate-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnFatInModerateQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enFatInModerateQuantity.code,
                enFatInModerateQuantity.name);
        nutrientLevel.code = "en:fat-in-moderate-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnSugarsInHighQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enSugarsInHighQuantity.code,
                enSugarsInHighQuantity.name);
        nutrientLevel.code = "en:sugars-in-high-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnFatInLowQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enFatInLowQuantity.code,
                enFatInLowQuantity.name);
        nutrientLevel.code = "en:fat-in-low-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnSaturatedFatInHighQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enSaturatedFatInHighQuantity.code,
                enSaturatedFatInHighQuantity.name);
        nutrientLevel.code = "en:saturated-fat-in-high-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnSaturatedFatInLowQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enSaturatedFatInLowQuantity.code,
                enSaturatedFatInLowQuantity.name);
        nutrientLevel.code = "en:saturated-fat-in-low-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnSugarsInLowQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enSugarsInLowQuantity.code,
                enSugarsInLowQuantity.name);
        nutrientLevel.code = "en:sugars-in-low-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnSaltInModerateQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enSaltInModerateQuantity.code,
                enSaltInModerateQuantity.name);
        nutrientLevel.code = "en:salt-in-moderate-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnSaltInLowQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enSaltInLowQuantity.code,
                enSaltInLowQuantity.name);
        nutrientLevel.code = "en:salt-in-low-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnSaltInHighQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enSaltInHighQuantity.code,
                enSaltInHighQuantity.name);
        nutrientLevel.code = "en:salt-in-high-quantity";
        return nutrientLevel;
    }

    public NutrientLevel getEnSaturatedFatInModerateQuantity() {
        NutrientLevel nutrientLevel = new NutrientLevel(enSaturatedFatInModerateQuantity.code,
                enSaturatedFatInModerateQuantity.name);
        nutrientLevel.code = "en:saturated-fat-in-moderate-quantity";
        return nutrientLevel;
    }
}
