package edu.uoc.tfg.nutriknow.sqlite.adapters;

import android.content.Context;
import android.database.Cursor;
import android.database.DatabaseUtils;
import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

import edu.uoc.tfg.nutriknow.sqlite.DataBaseHelper;

/**
 * Generic database adapter
 */
public class DataBaseAdapter {


    protected static final String DATABASE_NAME = "database.db.nutriknow";

    // Variable to hold the database instance
    protected static SQLiteDatabase db;

    // Context of the application using the database.
    protected Context context;

    // Database open/upgrade helper
    protected static DataBaseHelper dbHelper;

    /**
     * Check if a table exists in the database
     *
     * @param tableName name of the table
     * @param openDb    boolean
     * @return boolean
     */
    public boolean tableExists(String tableName, boolean openDb) {
        boolean exists = false;

        db = dbHelper.getReadableDatabase();

        long count = DatabaseUtils.queryNumEntries(db, tableName);
        if (count > 0) {
            exists = true;
        }

        Log.i(DATABASE_NAME, tableName + " table exists -> " + exists + " - " + count);
        return exists;
    }
}
