package edu.uoc.tfg.nutriknow.utils;

import android.content.Context;

import com.joanzapata.iconify.Icon;
import com.joanzapata.iconify.IconDrawable;
import com.joanzapata.iconify.Iconify;
import com.joanzapata.iconify.fonts.FontAwesomeModule;

/**
 * Utils class for using font awesome icons in views
 */
public class IconDrawableUtils {

    private static final int PX_TO_ADD = 4;

    static {
        Iconify.with(new FontAwesomeModule());
    }

    /**
     * Create font awesome icon drawable
     * @param ctx context
     * @param icon selected icon
     * @param size size of the icon
     * @param color color of the icon
     * @param addPx increase size of the icon
     * @return icon drawable
     */
    public static IconDrawable createIconDrawable(Context ctx, Icon icon, int size,
                                                  int color, boolean addPx) {
        IconDrawable iconDrawable = new IconDrawable(ctx, icon);
        iconDrawable.colorRes(color);
        if (addPx) {
            iconDrawable.sizePx(size + PX_TO_ADD);
        } else {
            iconDrawable.sizePx(size);
        }
        return iconDrawable;
    }
}
