package edu.uoc.tfg.nutriknow.utils;

import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;

import edu.uoc.tfg.nutriknow.R;

/**
 * Utils class for managing progress dialogs
 */
public class ProgressDialogUtils {

    /**
     * Create progress dialog
     *
     * @param ctx       context
     * @param messageId message to show
     * @return progress dialog
     */
    public static ProgressDialog createProgressDialog(Context ctx, int messageId) {

        final ProgressDialog progressDialog = new ProgressDialog(ctx,
                R.style.AppTheme_DarkDialog);
        progressDialog.setIndeterminateDrawable(ctx.getDrawable(R.mipmap.ic_launcher_round));
        progressDialog.setCancelable(false);
        progressDialog.setCanceledOnTouchOutside(false);
        progressDialog.setOnCancelListener(new Dialog.OnCancelListener() {

            @Override
            public void onCancel(DialogInterface dialog) {
            }
        });
        progressDialog.setIndeterminate(true);
        progressDialog.setMessage(ctx.getString(messageId));

        return progressDialog;
    }
}
